#include "led.h"
#include "delay.h"
#include "sys.h" 
#include "Display_EPD_W21_spi.h"
#include "Display_EPD_W21.h"
#include "Ap_29demo.h"	
 
//EPD
void EPD_init(void);
void pic_display(void);
void pic_display_white(void);
void EPD_sleep(void);
void EPD_refresh(void);
void lcd_chkstatus_M1(void);
void lcd_chkstatus_S1(void);
void lcd_chkstatus_M2(void);
void lcd_chkstatus_S2(void);
void lut(const unsigned char* lut_vcom1,const unsigned char* lut_ww1,const unsigned char* lut_bw1,const unsigned char* lut_wb1,const unsigned char* lut_bb1);
void EPD_lut_set(void);

void EPD_init_white(void); 
void lut_white(void);
void driver_delay_us(unsigned int xus)  //1us
{
	for(;xus>1;xus--);
}

void driver_delay_xms(unsigned long xms) //1ms
{	
    unsigned long i = 0 , j=0;

    for(j=0;j<xms;j++)
	{
        for(i=0; i<256; i++);
    }
}

 	
void delay_s(unsigned int xs) //1s
{
	while(xs--)
	delay_ms(1000);
}

//Tips//
/*When the electronic paper is refreshed in full screen, the picture flicker is a normal phenomenon, and the main function is to clear the display afterimage in the previous picture.
  When the local refresh is performed, the screen does not flash.*/
/*When you need to transplant the driver, you only need to change the corresponding IO. The BUSY pin is the input mode and the others are the output mode. */

int main(void)
 {
	delay_init();	    	 //Delay function initialization  
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2); 	
 	LED_Init();			     //LED port initialization
  GPIO_1248_Configuration(); //12.48 inch IO port initialization

while(1)
{	
	//picture1
	EPD_init(); //EPD init		
	pic_display();//picture1
	EPD_refresh();//EPD refresh
	EPD_sleep();//EPD_sleep,Sleep instruction is necessary, please do not delete!!!
  delay_s(5);	
	
	//all white
	EPD_init(); //EPD init		
  pic_display_white();//picture  white
	EPD_refresh();//EPD refresh
	EPD_init_white(); //EPD init		
	pic_display_white();//picture  white
	EPD_refresh();//EPD refresh
	EPD_sleep();//EPD_sleep,Sleep instruction is necessary, please do not delete!!!
	while(1);	
 }
}










 
////////////////////////////////////////////////////////////////////
void EPD_init(void)
{
	EPD_W21_Init();	//Electronic paper IC reset	

	EPD_W21_WriteCMD_M1(0x00);			//panel setting
	EPD_W21_WriteDATA_M1(0x2f);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	EPD_W21_WriteCMD_S1(0x00);			//panel setting
	EPD_W21_WriteDATA_S1(0x2f);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	//M2S2 turn  180
	EPD_W21_WriteCMD_M2(0x00);			//panel setting
	EPD_W21_WriteDATA_M2(0x23);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	EPD_W21_WriteCMD_S2(0x00);			//panel setting
	EPD_W21_WriteDATA_S2(0x23);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f

	EPD_W21_WriteCMD_M1(0x06);         //booster soft start
	EPD_W21_WriteDATA_M1 (0x17);		//A
	EPD_W21_WriteDATA_M1 (0x17);		//B
	EPD_W21_WriteDATA_M1 (0x39);		//C
	EPD_W21_WriteDATA_M1 (0x17);
	EPD_W21_WriteCMD_M2(0x06);         //booster soft start
	EPD_W21_WriteDATA_M2 (0x17);		//A
	EPD_W21_WriteDATA_M2 (0x17);		//B
	EPD_W21_WriteDATA_M2 (0x39);		//C
	EPD_W21_WriteDATA_M2 (0x17);

	EPD_W21_WriteCMD_M1(0x61);			//resolution setting
	EPD_W21_WriteDATA_M1 (0x02);
	EPD_W21_WriteDATA_M1 (0x88);       //source 648
	EPD_W21_WriteDATA_M1 (0x01);		//gate 492
	EPD_W21_WriteDATA_M1 (0xEC);
	EPD_W21_WriteCMD_S1(0x61);			//resolution setting
	EPD_W21_WriteDATA_S1 (0x02);
	EPD_W21_WriteDATA_S1 (0x90);       //source 656
	EPD_W21_WriteDATA_S1 (0x01);		//gate 492
	EPD_W21_WriteDATA_S1 (0xEC);
	EPD_W21_WriteCMD_M2(0x61);			//resolution setting
	EPD_W21_WriteDATA_M2 (0x02);
	EPD_W21_WriteDATA_M2 (0x90);       //source 656
	EPD_W21_WriteDATA_M2 (0x01);		//gate 492
	EPD_W21_WriteDATA_M2 (0xEC);
	EPD_W21_WriteCMD_S2(0x61);			//resolution setting
	EPD_W21_WriteDATA_S2 (0x02);
	EPD_W21_WriteDATA_S2 (0x88);       //source 648
	EPD_W21_WriteDATA_S2 (0x01);		//gate 492
	EPD_W21_WriteDATA_S2 (0xEC);

	EPD_W21_WriteCMD_ALL(0x15);			//
	EPD_W21_WriteDATA_ALL(0x20);		//

	EPD_W21_WriteCMD_ALL(0x50);			//
	EPD_W21_WriteDATA_ALL(0x31);		//
	EPD_W21_WriteDATA_ALL(0x07);


	EPD_W21_WriteCMD_ALL(0x60);
	EPD_W21_WriteDATA_ALL(0x22);

	EPD_W21_WriteCMD_M1(0xE0);			//POWER SETTING
	EPD_W21_WriteDATA_M1 (0x01);
	EPD_W21_WriteCMD_M2(0xE0);			//POWER SETTING
	EPD_W21_WriteDATA_M2 (0x01);

	EPD_W21_WriteCMD_ALL(0xE3);
	EPD_W21_WriteDATA_ALL(0x00);
	
  EPD_lut_set(); //Load waveform file

}
void EPD_lut_set(void)
{
	unsigned char temp;  //temperature
	unsigned char power_set;////POWER SETTING
  unsigned char pll_set;////PLL SETTING	
  unsigned char vcom_set;////VCOM SETTING
	//temperature
	EPD_W21_WriteCMD_M1(0x40);
	lcd_chkstatus_M1(); //waiting for the electronic paper IC to release the idle signal
	driver_delay_xms(300);
	temp=EPD_W21_ReadDATA_M1_temp();
	
	EPD_W21_WriteCMD_ALL(0xe0);//Cascade setting
	EPD_W21_WriteDATA_ALL(0x03);
	EPD_W21_WriteCMD_ALL(0xe5);//Force temperature
  EPD_W21_WriteDATA_ALL(temp);
	
	if((temp>0)&&(temp<=5))
	{
		power_set=0x0e;
		pll_set=0x06;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom1,lut_ww1,lut_bw1,lut_wb1,lut_bb1);
	}
	if((temp>5)&&(temp<=10))
	{
		power_set=0x0d;
		pll_set=0x06;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom2,lut_ww2,lut_bw2,lut_wb2,lut_bb2);
	}
	if((temp>10)&&(temp<=15))
	{
		power_set=0x0c;
		pll_set=0x06;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom3,lut_ww3,lut_bw3,lut_wb3,lut_bb3);
	}
	if((temp>15)&&(temp<=20))
	{
		power_set=0x0a;
		pll_set=0x06;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom4,lut_ww4,lut_bw4,lut_wb4,lut_bb4);
	}
	if((temp>20)&&(temp<=25))
	{
		power_set=0x08;
		pll_set=0x09;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom5,lut_ww5,lut_bw5,lut_wb5,lut_bb5);
	}
	if((temp>25)&&(temp<=30))
	{
		power_set=0x07;
		pll_set=0x09;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom6,lut_ww6,lut_bw6,lut_wb6,lut_bb6);
	}
	if((temp>30)&&(temp<=35))
	{
		power_set=0x07;
		pll_set=0x09;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom7,lut_ww7,lut_bw7,lut_wb7,lut_bb7);
	}
	if((temp>35)&&(temp<=40))
	{
		power_set=0x07;
		pll_set=0x09;
		vcom_set=0x18;
		EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M1 (0x07);
		EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M1 (power_set);
		EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
		EPD_W21_WriteDATA_M2 (0x07);
		EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
		EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
		EPD_W21_WriteDATA_M2 (power_set);
		
		EPD_W21_WriteCMD_ALL(0x30);			//PLL
		EPD_W21_WriteDATA_ALL(pll_set);		//50HZ

		EPD_W21_WriteCMD_M1(0x82);
		EPD_W21_WriteDATA_M1(vcom_set);
		EPD_W21_WriteCMD_M2(0x82);
		EPD_W21_WriteDATA_M2(vcom_set);
    lut(lut_vcom8,lut_ww8,lut_bw8,lut_wb8,lut_bb8);
	}

		
}
void EPD_init_white(void)
{
	EPD_W21_Init();   //Electronic paper IC reset	

	EPD_W21_WriteCMD_M1(0x00);			//panel setting
	EPD_W21_WriteDATA_M1(0x2f);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	EPD_W21_WriteCMD_S1(0x00);			//panel setting
	EPD_W21_WriteDATA_S1(0x2f);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	//M2S2 turn  180
	EPD_W21_WriteCMD_M2(0x00);			//panel setting
	EPD_W21_WriteDATA_M2(0x23);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	EPD_W21_WriteCMD_S2(0x00);			//panel setting
	EPD_W21_WriteDATA_S2(0x23);		//KW-3f   KWR-2F	BWROTP 0f	BWOTP 1f
	
	EPD_W21_WriteCMD_M1(0x01);			//POWER SETTING
	EPD_W21_WriteDATA_M1 (0x07);
	EPD_W21_WriteDATA_M1 (0x17);       //VGH=20V,VGL=-20V
	EPD_W21_WriteDATA_M1 (0x3F);		//VDH=15V
	EPD_W21_WriteDATA_M1 (0x3F);		//VDL=-15V
	EPD_W21_WriteDATA_M1 (0x0d);
	EPD_W21_WriteCMD_M2(0x01);			//POWER SETTING
	EPD_W21_WriteDATA_M2 (0x07);
	EPD_W21_WriteDATA_M2 (0x17);       //VGH=20V,VGL=-20V
	EPD_W21_WriteDATA_M2 (0x3F);		//VDH=15V
	EPD_W21_WriteDATA_M2 (0x3F);		//VDL=-15V
	EPD_W21_WriteDATA_M2 (0x0d);

	EPD_W21_WriteCMD_M1(0x06);         //booster soft start
	EPD_W21_WriteDATA_M1 (0x17);		//A
	EPD_W21_WriteDATA_M1 (0x17);		//B
	EPD_W21_WriteDATA_M1 (0x39);		//C
	EPD_W21_WriteDATA_M1 (0x17);
	EPD_W21_WriteCMD_M2(0x06);         //booster soft start
	EPD_W21_WriteDATA_M2 (0x17);		//A
	EPD_W21_WriteDATA_M2 (0x17);		//B
	EPD_W21_WriteDATA_M2 (0x39);		//C
	EPD_W21_WriteDATA_M2 (0x17);

	EPD_W21_WriteCMD_M1(0x61);			//resolution setting
	EPD_W21_WriteDATA_M1 (0x02);
	EPD_W21_WriteDATA_M1 (0x88);       //source 648
	EPD_W21_WriteDATA_M1 (0x01);		//gate 492
	EPD_W21_WriteDATA_M1 (0xEC);
	EPD_W21_WriteCMD_S1(0x61);			//resolution setting
	EPD_W21_WriteDATA_S1 (0x02);
	EPD_W21_WriteDATA_S1 (0x90);       //source 656
	EPD_W21_WriteDATA_S1 (0x01);		//gate 492
	EPD_W21_WriteDATA_S1 (0xEC);
	EPD_W21_WriteCMD_M2(0x61);			//resolution setting
	EPD_W21_WriteDATA_M2 (0x02);
	EPD_W21_WriteDATA_M2 (0x90);       //source 656
	EPD_W21_WriteDATA_M2 (0x01);		//gate 492
	EPD_W21_WriteDATA_M2 (0xEC);
	EPD_W21_WriteCMD_S2(0x61);			//resolution setting
	EPD_W21_WriteDATA_S2 (0x02);
	EPD_W21_WriteDATA_S2 (0x88);       //source 648
	EPD_W21_WriteDATA_S2 (0x01);		//gate 492
	EPD_W21_WriteDATA_S2 (0xEC);


	EPD_W21_WriteCMD_ALL(0x15);			//
	EPD_W21_WriteDATA_ALL(0x20);		//

	EPD_W21_WriteCMD_ALL(0x30);			//PLL
	EPD_W21_WriteDATA_ALL(0x08);		//50HZ

	EPD_W21_WriteCMD_ALL(0x50);			//
	EPD_W21_WriteDATA_ALL(0x31);		//
	EPD_W21_WriteDATA_ALL(0x07);


	EPD_W21_WriteCMD_ALL(0x60);
	EPD_W21_WriteDATA_ALL(0x22);

	EPD_W21_WriteCMD_M1(0xE0);			//POWER SETTING
	EPD_W21_WriteDATA_M1 (0x01);
	EPD_W21_WriteCMD_M2(0xE0);			//POWER SETTING
	EPD_W21_WriteDATA_M2 (0x01);

	EPD_W21_WriteCMD_ALL(0xE3);
	EPD_W21_WriteDATA_ALL(0x00);


	EPD_W21_WriteCMD_M1(0x82);
	EPD_W21_WriteDATA_M1(0x1c);
	EPD_W21_WriteCMD_M2(0x82);
	EPD_W21_WriteDATA_M2(0x1c);

	lut_white(); 
}
void EPD_refresh(void)
{
	EPD_W21_WriteCMD_M1M2(0x04);
  delay_ms(300);
	EPD_W21_WriteCMD_ALL(0x12);			//DISPLAY REFRESH
	lcd_chkstatus_M1();  //waiting for the electronic paper IC to release the idle signal
	lcd_chkstatus_S1();  //waiting for the electronic paper IC to release the idle signal
	lcd_chkstatus_M2();  //waiting for the electronic paper IC to release the idle signal
	lcd_chkstatus_S2();  //waiting for the electronic paper IC to release the idle signal
}
	//////////Enter sleep//////////////////////////////
void EPD_sleep(void)
{
	EPD_W21_WriteCMD_ALL(0X02);  	//power off
	delay_ms(1000);

	EPD_W21_WriteCMD_ALL(0X07);  	//deep sleep
	EPD_W21_WriteDATA_ALL(0xA5);
	delay_s(1);
}

//picture//
void pic_display(void)
{
	unsigned int column,row;
		////////M1 part//////////648*492
		EPD_W21_WriteCMD_M1(0x10);
		for(column=492;column<984;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_M1(~gImage_1304x984_black[row+column*163]);
		}
		EPD_W21_WriteCMD_M1(0x13);
		for(column=492;column<984;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_M1(gImage_1304x984_red[row+column*163]);
		}
		
		////////S1 part//////////656*492
		EPD_W21_WriteCMD_S1(0x10);
		for(column=492;column<984;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_S1(~gImage_1304x984_black[row+column*163]);
		}
		EPD_W21_WriteCMD_S1(0x13);
		for(column=492;column<984;column++)
		 for(row=81;row<163;row++)
		{                                                                                                         
		EPD_W21_WriteDATA_S1(gImage_1304x984_red[row+column*163]);
		}
		
		////////M2 part//////////656*492
		EPD_W21_WriteCMD_M2(0x10);
		for(column=0;column<492;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_M2(~gImage_1304x984_black[row+column*163]);
		}
		EPD_W21_WriteCMD_M2(0x13);
		for(column=0;column<492;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_M2(gImage_1304x984_red[row+column*163]);
		}
		////////S2 part//////////648*492
		EPD_W21_WriteCMD_S2(0x10);
		for(column=0;column<492;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_S2(~gImage_1304x984_black[row+column*163]);
		}
		EPD_W21_WriteCMD_S2(0x13);
		for(column=0;column<492;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_S2(gImage_1304x984_red[row+column*163]);
		}

}
//picture white//
void pic_display_white(void)
{
	unsigned int column,row;
		////////M1 part//////////648*492
		EPD_W21_WriteCMD_M1(0x10);
		for(column=492;column<984;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_M1(0xff);
		}
		EPD_W21_WriteCMD_M1(0x13);
		for(column=492;column<984;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_M1(0x00);
		}
		
		////////S1 part//////////656*492
		EPD_W21_WriteCMD_S1(0x10);
		for(column=492;column<984;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_S1(0xff);
		}
		EPD_W21_WriteCMD_S1(0x13);
		for(column=492;column<984;column++)
		 for(row=81;row<163;row++)
		{                                                                                                         
		EPD_W21_WriteDATA_S1(0x00);
		}
		
		////////M2 part//////////656*492
		EPD_W21_WriteCMD_M2(0x10);
		for(column=0;column<492;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_M2(0xff);
		}
		EPD_W21_WriteCMD_M2(0x13);
		for(column=0;column<492;column++)
		 for(row=81;row<163;row++)
		{
		EPD_W21_WriteDATA_M2(0x00);
		}
		////////S2 part//////////648*492
		EPD_W21_WriteCMD_S2(0x10);
		for(column=0;column<492;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_S2(0xff);
		}
		EPD_W21_WriteCMD_S2(0x13);
		for(column=0;column<492;column++)
		 for(row=0;row<81;row++)
		{
		EPD_W21_WriteDATA_S2(0x00);
		}

}
void lcd_chkstatus_M1(void)
{
	unsigned char busy;
	do
		{
		EPD_W21_WriteCMD_M1(0x71);
		busy = EPD_W21_ReadDATA_M1;
		busy =!(busy & 0x01);
		}
	while(busy);
  driver_delay_xms(200);
}

void lcd_chkstatus_M2(void)
{
	unsigned char busy;
	do
		{
		EPD_W21_WriteCMD_M2(0x71);
		busy = EPD_W21_ReadDATA_M2;
		busy =!(busy & 0x01);
		}
	while(busy);
  driver_delay_xms(200);
}
void lcd_chkstatus_S1(void)
{
	unsigned char busy;
	do
		{
		EPD_W21_WriteCMD_S1(0x71);
		busy = EPD_W21_ReadDATA_S1;
		busy =!(busy & 0x01);
		}
	while(busy);
  driver_delay_xms(200);
}

void lcd_chkstatus_S2(void)
{
	unsigned char busy;
	do
		{
		EPD_W21_WriteCMD_S2(0x71);
		busy = EPD_W21_ReadDATA_S2;
		busy =!(busy & 0x01);
		}
	while(busy);
  driver_delay_xms(200);
}
void lut(const unsigned char* lut_vcom1,const unsigned char* lut_ww1,const unsigned char* lut_bw1,const unsigned char* lut_wb1,const unsigned char* lut_bb1)
{


	unsigned int count;

	EPD_W21_WriteCMD_ALL(0x20);							//vcom
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(*lut_vcom1++);}

			EPD_W21_WriteCMD_ALL(0x21);							//red not use
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(*lut_ww1++);}

			EPD_W21_WriteCMD_ALL(0x22);							//bw r
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(*lut_bw1++);}			// bw=r

			EPD_W21_WriteCMD_ALL(0x23);							//wb w
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(*lut_wb1++);}			// wb=w

			EPD_W21_WriteCMD_ALL(0x24);							//bb b
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(*lut_bb1++);}			// bb=b

			EPD_W21_WriteCMD_ALL(0x25);							//bb b
						for(count=0;count<60;count++)
							{EPD_W21_WriteDATA_ALL(*lut_ww1++);}			// bb=b
}

void lut_white(void)
{
	unsigned int count;

	EPD_W21_WriteCMD_ALL(0x20);							//vcom
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(lut_vcom11[count]);}

			EPD_W21_WriteCMD_ALL(0x21);							//red not use
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(lut_ww11[count]);}

			EPD_W21_WriteCMD_ALL(0x22);							//bw r
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(lut_bw11[count]);}			// bw=r

			EPD_W21_WriteCMD_ALL(0x23);							//wb w
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(lut_wb11[count]);}			// wb=w

			EPD_W21_WriteCMD_ALL(0x24);							//bb b
			for(count=0;count<60;count++)
				{EPD_W21_WriteDATA_ALL(lut_bb11[count]);}			// bb=b

			EPD_W21_WriteCMD_ALL(0x25);							//bb b
						for(count=0;count<60;count++)
							{EPD_W21_WriteDATA_ALL(lut_ww11[count]);}			// bb=b
}





